from codecs import encode
from email import header
from email.mime import base
import os, re
from random import getrandbits
import requests
import base64
import time
from loguru import logger

token = None

def get_token():
    global token
    url = "http://192.168.125.149:19080/oauth/token"
    global responseData
    if token == None:
        headers = {
                    "Authorization": "Basic YUhCQ1hwMjdMcjJ3d3lQQTFhNnZBTHZzQVRIR2ZxSnA6OWVKSmNmY1hMTnBnOFBpRA==",
                    "Accept": "*/*",
                    "Accept-Encoding": "gzip, deflate, br",
                    "User-Agent": "TacOS Cloud Desktop/V1.0",
                    "X-TACOS-ENV": "test",
                    "Content-Type": "application/x-www-form-urlencoded",
                    "Host": "192.168.125.149:19080",
                    "Content-Length": "56",
                    "Expect": "100-continue",
                    "Connection": "keep-alive",
        }

        body = {    "username": "luweisen",
                    "grant_type": "password",
                    "password": "test1234!",}
        r = requests.post(url, data=body, headers= headers)
        try:
            responseData = r.json()["data"]
            token = r.json()["data"]["access_token"]
        except:
            token = ''

    logger.info(f"setup_testcase, tokenResponse :  {responseData}")
    logger.info(f"setup_testcase, token : {token}")
    return token

#统一登录-资源所有者密码登录
def get_oss_resource_token():
    global token
    url = "http://192.168.118.115:8003/oauth/token"
    if token == None:
        userName = "password"
        passWord = "123456"
        basicInput = userName + ":" + passWord
        tmp = base64.b64encode(basicInput.encode('utf-8'))
        basicOutput ="Basic " + str(tmp,'utf-8')
        headers = {
            "Content-Type": "application/x-www-form-urlencoded",
            "Authorization": basicOutput,
        }

        body = {    "username": userName,
                    "grant_type": "password",
                    "password": passWord,}
        r = requests.post(url, data=body, headers= headers)
        try:
            token = r.json()["data"]["access_token"]
        except:
            token = ''
    
    logger.info(f"setup_testcase, token : {token}")
    return token

#统一登录-授权码登录
def get_oss_auth_token():
    global token
    #登录获取cookie
    if token == None:
        userName = "aicity"
        passWord = "123456"

        clientId = "autoTest"
        clientPassword = "123456"

        redirectUri = "http://www.baidu.com"
        responseType = "code"

        grantType = "authorization_code"
        scope = "client"

        cookie = None
        tmpcookies = None
        basicInput = clientId + ":" + clientPassword
        tmp = base64.b64encode(basicInput.encode('utf-8'))
        basicOutput ="Basic " + str(tmp,'utf-8')

        session = None
        url = "http://192.168.118.115:8003/usernamePassword"
        
        headers = {
            "Content-Type": "application/x-www-form-urlencoded",
        }

        body = {    "username": userName,
                    "grant_type": "password",
                    "password": passWord,}
        r = requests.post(url, data=body, headers= headers)

        try:
            sessionWithPath = r.headers.get('Set-Cookie')

            session = re.findall("SESSION=(.+?);",sessionWithPath)[0]
            
        except:
            session = None

        url = "http://192.168.118.115:8003/oauth/authorize"
        if session != None:
            # headers = {
            #     # "Content-Type": "application/x-www-form-urlencoded",
            #     # "Cookie": session
            #     "Connection": "keep-alive",
            #     "Host": "192.168.118.115:8003",
            #     "User-Agent": "Apache-HttpClient/4.5.12 (Java/1.8.0_291)",
            # }

            body = {    "client_id": clientId,
                        "redirect_uri": redirectUri,
                        "response_type": responseType,
                    }

            cookie_dict = {'SESSION': session}
            #将CookieJar转为字典：
            tmpcookies = requests.utils.dict_from_cookiejar(r.cookies)

            #将字典转为CookieJar：
            tmpcookies = requests.utils.cookiejar_from_dict(cookie_dict, cookiejar=None, overwrite=True)

            #其中cookie_dict是要转换字典
            #转换完之后就可以把它赋给cookies 并传入到session中了：
            s = requests.Session()
            s.cookies = tmpcookies

            r = requests.get(url, params=body, headers= headers, cookies = tmpcookies, allow_redirects=False)
            # , cookies= s.cookies)
            try:
                codeWith = r.headers.get('Location')
                code = re.findall("code=(.*)", codeWith)
            except:
                code = None

        url = "http://192.168.118.115:8003/oauth/token"
        if code != None:
            
            headers = {
                "Content-Type": "application/x-www-form-urlencoded",
                "Authorization": basicOutput,
                "Cookie": session
            }

            body = {    "code": code,
                        "redirect_uri": redirectUri,
                        "grant_type": grantType,
                        "scope": scope,
                        }
            r = requests.post(url, data=body, headers= headers, cookies = tmpcookies)
            
            try:
                token = r.json()["data"]["access_token"]
            except:
                token = ''
    
    logger.info(f"setup_testcase, token : {token}")
    return token

# 根据接口响应的状态码来进行不同时间的延迟等待。
def teardown_hook_sleep_N_secs(response, n_secs):
    """ sleep n seconds after request
    """
    if response.status_code == 200:
        time.sleep(0.1)
    else:
        time.sleep(n_secs)


def get_fix_token():
    token = 'e3cd4930-44de-43f1-b8cd-5ddab341e450'
    return token

# if "__name__" == "__main__":
#     logger.info("start debugtalk")
#     a = get_token()
#     print(a)